/**
******************************************************************************
* @file    CX800D_Port.c
* @author  CWX Application Team
* @version V1.0
* @date    07-September-2018
* @brief   
******************************************************************************
* @attention
*
* <h2><center>&copy; COPYRIGHT 2018 Ψо</center></h2>
*
******************************************************************************
*/
/* Includes ------------------------------------------------------------------*/
#include "stm32f1xx_hal.h"
#include "cx800D.h"

/********************************************************************************************
*                                                                                           *
*                              funtion                                                      *
*                                                                                           *
*********************************************************************************************
*/
extern UART_HandleTypeDef huart2;
/*************************************************************
//            Port
//˵//Ͷֽ
*/
void Uart_SendMByte(u8* buf, u8 len)
{
	 HAL_UART_Transmit(&huart2, (uint8_t*)buf, len,0xffff);
}




#if   RECIEVE_RTS_MODE     //ifշ
/********************************************************************************************
*                                                                                           *
*                              ڽգƲҪ                                     *
*                                                                                           *
*********************************************************************************************
ʵ˼·ʵһѭbufжUSART2_IRQHandler()յݷbufferУCX_UART_ReadByte
          bufferݡ
*/

#ifndef HAL_UART_ISR_RX_MAX
#define HAL_UART_ISR_RX_MAX        128//buffer С
#endif


typedef struct
{
	uint8_t rxBuf[HAL_UART_ISR_RX_MAX];

	uint8_t rxHead;
	volatile	uint8_t rxTail;
} uartISRCfg_t;

static uartISRCfg_t isrCfg;

/*************************************************************
//            void __UART_RxISR(uint8_t ch)
//˵: buffer
*/
static void __UART_RxISR(uint8_t ch)
{
		isrCfg.rxBuf[isrCfg.rxTail] = ch;
		if (++isrCfg.rxTail >= HAL_UART_ISR_RX_MAX)
		{
			isrCfg.rxTail = 0;
		}
}

/*************************************************************
//            u8 CX_UART_ReadByte(void);
//˵: ӻȡһbyte
*/
CX_BOOL CX_UART_ReadByte(u8* Data)
{
	if(isrCfg.rxHead != isrCfg.rxTail)
	{
		*Data = isrCfg.rxBuf[isrCfg.rxHead++];
		if (isrCfg.rxHead >= HAL_UART_ISR_RX_MAX)
		{
			isrCfg.rxHead = 0;
		}
		return CX_TRUE;
	}
	return CX_FALSE;
}


/**stm32 жϳ
* @brief This function handles USART2 global interrupt.
*/
void USART2_IRQHandler(void)
{
  /* USER CODE BEGIN USART2_IRQn 0 */

  /* USER CODE END USART2_IRQn 0 */
 // HAL_UART_IRQHandler(&huart2);

    /* UART in mode Receiver -------------------------------------------------*/
    if((huart2.Instance->SR & USART_SR_RXNE) != RESET)
    {
      __UART_RxISR((uint8_t)(huart2.Instance->DR & (uint8_t)0x00FF));
      return;
    }
  /* USER CODE BEGIN USART2_IRQn 1 */

  /* USER CODE END USART2_IRQn 1 */
}
#endif
